import { toPath } from "./path";
import { updateIn } from "./update-in";
/**
 * Unchecked version of {@link deleteIn}. Path can be given as string or
 * tuple.
 *
 * @example
 * ```ts
 * // unchecked
 * deleteIn({ a: { b: { c: 23 } } }, "a.b.c");
 * // { a: { b: { } } }
 * ```
 *
 * @param state -
 * @param path -
 */
export const deleteInUnsafe = (state, path) => deleteIn(state, path);
export function deleteIn(state, path) {
    const ks = toPath(path).slice();
    if (ks.length) {
        const k = ks.pop();
        return updateIn(state, ks, (x) => ((x = Object.assign({}, x)), delete x[k], x));
    }
}
